package com.company.parentchildtest.listener;

import com.company.parentchildtest.entity.BaseEntity;
import io.jmix.core.event.EntityChangedEvent;
import io.jmix.core.event.EntityLoadingEvent;
import io.jmix.core.event.EntitySavingEvent;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import org.springframework.transaction.event.TransactionalEventListener;

@Component
public class BaseEntityEventListener {
    private static final Logger log = LoggerFactory.getLogger(BaseEntityEventListener.class);

    @EventListener
    public void onBaseEntityLoading(EntityLoadingEvent<BaseEntity> event) {
        log.warn("---- onBaseEntityLoading");
    }

    @EventListener
    public void onBaseEntitySaving(EntitySavingEvent<BaseEntity> event) {
        log.warn("---- onBaseEntitySaving");

    }

    @EventListener
    public void onBaseEntityChangedBeforeCommit(EntityChangedEvent<BaseEntity> event) {
        log.warn("---- onBaseEntityChangedBeforeCommit");

    }

    @TransactionalEventListener
    public void onBaseEntityChangedAfterCommit(EntityChangedEvent<BaseEntity> event) {
        log.warn("---- onBaseEntityChangedAfterCommit");

    }
}